' ShimadzuScan.bas for FilmStar MEASURE
' Copyright 1997-2022 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program imports Shimadzu spectra into FilmStar MEASURE.
' Sample spectra are normalized for Baseline, Reference, Standard values
'
' To exit the program, click Cancel in the file name dialog

Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, O-Z
Dim sType$, dName$, fName$, file$

' If you have difficulties, check that your Shimadzu file has
' the same format as sample file ShimadzuScan.txt, It may be
' necessary to modify nHeaders
Const nHeaders = 2	' Number of header lines

' Change "txt" to "asc" etc. if necessary
Const Ext$ = "txt"  ' Shimadzu spectra file extension

Sub Main
    dName$ = IniString("Shimadzu", "SpcPath")
    If dName$ = "" Then dName$ = "C:\Winfilm\Spectra"
    OpenFile
    WriteIniString "Shimadzu", "SpcPath", dName$
End Sub

Sub OpenFile
    Dim i, s$
    Select Case DataType
    Case 1
        s$ = " Sample"
    Case 2
        s$ = " 0% Baseline"
    Case 3
        s$ = " Reference"
    End Select
    file$ = GetFilePath$(, Ext$, dName$, "Open Shimadzu" & s$ & " spectrum", 0)
    If file$ = "" Then
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)     ' Directory
                fName$ = Right$(file$, Len(file$) - i)
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    Dim i, k, xDat(), yDat(), dum$, s$
    If fName$ = "" Then Exit Sub	' Quit if no data
    On Error Resume Next
    Open file$ For Input As #1
    For i = 1 To nHeaders
        Line Input #1, s$
    Next i
    Do  While Not EOF(1)    ' Get # data points
        Line Input #1, s$
        k = k + 1
    Loop
    Close #1
    ReDim sf$(1 To k)
    Open file$ For Input As #1
        For i = 1 To nHeaders
        Line Input #1, s$
    Next i
    For i = 1 To k
        Line Input #1, sf$(k - i + 1)
    Next i
    Close #1
    ReDim xDat(k), yDat(k)
    For i = 1 To k
        xDat(i) = Val(Split(sf$(i), ",")(0))
        yDat(i) = .01 * Val(Split(sf$(i), ",")(1))
    Next i
    Spectrum_X = xDat: Spectrum_Y = yDat
    If DataType = 1 Then DataReduce    ' Disable or delete if running from a Scan Macro
    AxesDraw
    Replot
    Busy False
End Sub
